/*
 * TemplateAction.java
 * 
 * Copyright (c) 2002 Boxed-Economy Project.  All rights reserved.
 */
package org.boxed_economy.besp.model.fmfw.behavior;

import org.apache.log4j.Logger;
import org.boxed_economy.besp.model.fmfw.Behavior;

/**
 * @author macchan
 * @version $Id: TemplateAction.java,v 1.1 2004/03/21 12:07:48 macchan Exp $
 * Not Serializable!
 */
public abstract class TemplateAction implements Action {

	private static final Logger logger =
		Logger.getLogger(TemplateAction.class.getName());

	private Behavior behavior = null;

	/**
	 * Constructor for TemplateAction.
	 */
	public TemplateAction() {
	}

	/**
	 * Returns the behavior.
	 * @return Behavior
	 */
	public final Behavior getBehavior() {
		return behavior;
	}

	/**
	 * Sets the behavior.
	 * @param behavior The behavior to set
	 */
	public final void setBehavior(Behavior behavior) {
		this.behavior = behavior;
	}

	/**
	 * O擾܂
	 */
	public String toString() {
		return "<<TemplateAction>>" + this.getClass().getName();
	}

}
