/*
 * UpdateEventDeliverer.java
 * Copyright (c) 2002 Boxed-Economy Project.  All rights reserved.
 */
package org.boxed_economy.besp.presentation;

import org.boxed_economy.besp.model.fmfw.update.TradeListener;
import org.boxed_economy.besp.model.fmfw.update.UpdateAgentListener;
import org.boxed_economy.besp.model.fmfw.update.UpdateBehaviorListener;
import org.boxed_economy.besp.model.fmfw.update.UpdateChannelListener;
import org.boxed_economy.besp.model.fmfw.update.UpdateClockListener;
import org.boxed_economy.besp.model.fmfw.update.UpdateInformationListener;
import org.boxed_economy.besp.model.fmfw.update.UpdateRelationListener;
import org.boxed_economy.besp.model.fmfw.update.UpdateStepListener;
import org.boxed_economy.besp.model.fmfw.update.UpdateWorldListener;

/**
 * XVCxgzM҂K肵܂
 * 
 * ȎNX:
 * PresentationComponent
 * UpdateEventManager
 * 
 * @author macchan
 * @version $Id: UpdateEventDeliverer.java,v 1.2 2004/03/21 21:57:48 macchan Exp $
 */
public interface UpdateEventDeliverer {

	/*********************
	 * Add Update Listener
	 *********************/

	public void addUpdateAgentListener(UpdateAgentListener listener);
	public void addUpdateBehaviorListener(UpdateBehaviorListener listener);
	public void addUpdateChannelListener(UpdateChannelListener listener);
	public void addUpdateClockListener(UpdateClockListener listener);
	public void addUpdateStepListener(UpdateStepListener listener);
	public void addUpdateInformationListener(UpdateInformationListener listener);
	public void addUpdateRelationListener(UpdateRelationListener listener);
	public void addUpdateWorldListener(UpdateWorldListener listener);
	public void addTradeListener(TradeListener listener);

	/*************************
	 * Remove Update Listener
	 *************************/

	public void removeUpdateAgentListener(UpdateAgentListener listener);
	public void removeUpdateBehaviorListener(UpdateBehaviorListener listener);
	public void removeUpdateChannelListener(UpdateChannelListener listener);
	public void removeUpdateClockListener(UpdateClockListener listener);
	public void removeUpdateStepListener(UpdateStepListener listener);
	public void removeUpdateInformationListener(UpdateInformationListener listener);
	public void removeUpdateRelationListener(UpdateRelationListener listener);
	public void removeUpdateWorldListener(UpdateWorldListener listener);
	public void removeTradeListener(TradeListener listener);
}
